CREATE SCHEMA Historisierung

-- Historie:
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE historisches_Objekt (
   historisches_Objekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_historisches_Objekt
      INTEGER NOT NULL REFERENCES Art_historisches_Objekt,
   erzeugt_von_Ereignis
      INTEGER NOT NULL REFERENCES Ereignis,
   geloescht_von_Ereignis
      INTEGER REFERENCES Ereignis,
   hat_Vorgaenger_hist_Objekt
      INTEGER REFERENCES historisches_Objekt
)

CREATE TABLE Art_historisches_Objekt (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(30) NOT NULL
)

INSERT INTO Art_historisches_Objekt VALUES (1,'Strasse')
INSERT INTO Art_historisches_Objekt VALUES (2,'Strasse_Netzknoten')
INSERT INTO Art_historisches_Objekt VALUES (3,'Netzknoten')
INSERT INTO Art_historisches_Objekt VALUES (4,'BAB_Knotennummer')
INSERT INTO Art_historisches_Objekt VALUES (5,'Abschnitt')
INSERT INTO Art_historisches_Objekt VALUES (6,'Ast')
INSERT INTO Art_historisches_Objekt VALUES (7,'Verkehrliche_Verknuepfung')
INSERT INTO Art_historisches_Objekt VALUES (8,'Nullpunkt')
INSERT INTO Art_historisches_Objekt VALUES (9,'Kilometrierung')
INSERT INTO Art_historisches_Objekt VALUES (10,'Teilbauwerk')
INSERT INTO Art_historisches_Objekt VALUES (11,'Bruecke')
INSERT INTO Art_historisches_Objekt VALUES (12,'Verkehrszeichenbruecke')
INSERT INTO Art_historisches_Objekt VALUES (13,'Tunnel_Trogbauwerk')
INSERT INTO Art_historisches_Objekt VALUES (14,'Laermschutzbauwerk')
INSERT INTO Art_historisches_Objekt VALUES (15,'Stuetzbauwerk')
INSERT INTO Art_historisches_Objekt VALUES (16,'sonstiges_Bauwerk')
INSERT INTO Art_historisches_Objekt VALUES (17,'Schichtbegrenzung')
INSERT INTO Art_historisches_Objekt VALUES (18,'Streifenbegrenzung')
INSERT INTO Art_historisches_Objekt VALUES (19,'Gewaesserkreuzung')
INSERT INTO Art_historisches_Objekt VALUES (20,'Bahnkreuzung')
INSERT INTO Art_historisches_Objekt VALUES (21,'Kreuzung_Strasse_Weg')
INSERT INTO Art_historisches_Objekt VALUES (22,'Fussgaengerueberweg')
INSERT INTO Art_historisches_Objekt VALUES (23,'Durchlass')
INSERT INTO Art_historisches_Objekt VALUES (24,'Aufstellvorrichtung')
INSERT INTO Art_historisches_Objekt VALUES (25,'Netzbereich')
INSERT INTO Art_historisches_Objekt VALUES (26,'Bundesland')
INSERT INTO Art_historisches_Objekt VALUES (27,'Regierungsbezirk')
INSERT INTO Art_historisches_Objekt VALUES (28,'Kreis_kreisfreie_Stadt')
INSERT INTO Art_historisches_Objekt VALUES (29,'Gemeindebezirk')
INSERT INTO Art_historisches_Objekt VALUES (30,'Ortsteil')
INSERT INTO Art_historisches_Objekt VALUES (31,'Land_Ministerium')
INSERT INTO Art_historisches_Objekt VALUES (32,'Regierungspraesidium_Landesamt')
INSERT INTO Art_historisches_Objekt VALUES (33,'Amt')
INSERT INTO Art_historisches_Objekt VALUES (34,'Meisterei')
INSERT INTO Art_historisches_Objekt VALUES (35,'Kreisverwaltung')
INSERT INTO Art_historisches_Objekt VALUES (36,'Gemeindeverwaltung')
INSERT INTO Art_historisches_Objekt VALUES (37,'UI_Vereinbarung')
INSERT INTO Art_historisches_Objekt VALUES (38,'Baulast')
INSERT INTO Art_historisches_Objekt VALUES (39,'Schutzzone')
INSERT INTO Art_historisches_Objekt VALUES (40,'Block')
INSERT INTO Art_historisches_Objekt VALUES (41,'OD_FS')
INSERT INTO Art_historisches_Objekt VALUES (42,'Widmung')
INSERT INTO Art_historisches_Objekt VALUES (43,'Leitung')
INSERT INTO Art_historisches_Objekt VALUES (44,'Markierung')
INSERT INTO Art_historisches_Objekt VALUES (45,'Schutzplanke')
INSERT INTO Art_historisches_Objekt VALUES (46,'Nebenanlage')
INSERT INTO Art_historisches_Objekt VALUES (47,'Rastanlage_nicht_bew')
INSERT INTO Art_historisches_Objekt VALUES (48,'Rastanlage_bew')
INSERT INTO Art_historisches_Objekt VALUES (49,'Nebenbetrieb')
INSERT INTO Art_historisches_Objekt VALUES (50,'Schicht')
INSERT INTO Art_historisches_Objekt VALUES (51,'Querschnittstreifen')
INSERT INTO Art_historisches_Objekt VALUES (52,'Bauklasse_Oberbau')
INSERT INTO Art_historisches_Objekt VALUES (53,'Bauweise_Oberbau')
INSERT INTO Art_historisches_Objekt VALUES (54,'Regelquerschnitt')
INSERT INTO Art_historisches_Objekt VALUES (55,'Bahnigkeit')
INSERT INTO Art_historisches_Objekt VALUES (56,'Fahrbahnlaengsneigung')
INSERT INTO Art_historisches_Objekt VALUES (57,'Fahrbahnquerneigung')
INSERT INTO Art_historisches_Objekt VALUES (58,'Hindernis')
INSERT INTO Art_historisches_Objekt VALUES (59,'SB_Wirkungsbereiche')
INSERT INTO Art_historisches_Objekt VALUES (60,'raeumlicher_Gueltigkeitsber')
INSERT INTO Art_historisches_Objekt VALUES (61,'Strecke')
INSERT INTO Art_historisches_Objekt VALUES (62,'Strecke_SO')
INSERT INTO Art_historisches_Objekt VALUES (63,'Teilnetz')
INSERT INTO Art_historisches_Objekt VALUES (64,'Route')
INSERT INTO Art_historisches_Objekt VALUES (65,'Strassenelement')
INSERT INTO Art_historisches_Objekt VALUES (66,'sonstige_UI_Partner')
INSERT INTO Art_historisches_Objekt VALUES (67,'Leitungsverlauf')
INSERT INTO Art_historisches_Objekt VALUES (68,'Leitungstraeger')
INSERT INTO Art_historisches_Objekt VALUES (69,'Leitungsart')
INSERT INTO Art_historisches_Objekt VALUES (70,'entwaesserte_Fahrbahnflaeche')
INSERT INTO Art_historisches_Objekt VALUES (71,'Lage_Entwaesserung')
INSERT INTO Art_historisches_Objekt VALUES (72,'Art_der_Entwaesserung')
INSERT INTO Art_historisches_Objekt VALUES (73,'Fahrstreifen_Nummer')
INSERT INTO Art_historisches_Objekt VALUES (74,'max_Hoehe')
INSERT INTO Art_historisches_Objekt VALUES (75,'Fkt_d_Verb_im_Knotenpktber')
INSERT INTO Art_historisches_Objekt VALUES (76,'Schichtart')
INSERT INTO Art_historisches_Objekt VALUES (77,'Schichtmaterial')
INSERT INTO Art_historisches_Objekt VALUES (78,'Streifenart')
INSERT INTO Art_historisches_Objekt VALUES (79,'Baustoff')
INSERT INTO Art_historisches_Objekt VALUES (80,'Profil')
INSERT INTO Art_historisches_Objekt VALUES (81,'automatische_Dauerzaehlstelle')
INSERT INTO Art_historisches_Objekt VALUES (82,'Erfassungsergebnisse')
INSERT INTO Art_historisches_Objekt VALUES (83,'Klassenunterscheidung')
INSERT INTO Art_historisches_Objekt VALUES (84,'Fahrstreifenzuordnung')
INSERT INTO Art_historisches_Objekt VALUES (85,'Art_der_registrierten_Daten')
INSERT INTO Art_historisches_Objekt VALUES (86,'Detektorart')
INSERT INTO Art_historisches_Objekt VALUES (87,'Art_der_Registrierung')
INSERT INTO Art_historisches_Objekt VALUES (88,'Fahrstreifenzuteilung')
INSERT INTO Art_historisches_Objekt VALUES (89,'manuelle_Zaehlstelle')
INSERT INTO Art_historisches_Objekt VALUES (90,'Gueltigkeitsbereich_AV')
INSERT INTO Art_historisches_Objekt VALUES (91,'Hochrechnungsergebnisse')
INSERT INTO Art_historisches_Objekt VALUES (92,'Angaben_z_Strassenquerschnitt')
INSERT INTO Art_historisches_Objekt VALUES (93,'Richtungskennung')
INSERT INTO Art_historisches_Objekt VALUES (94,'Bemerkungskennziffern')
INSERT INTO Art_historisches_Objekt VALUES (95,'benachbarte_Anschlussstellen')
INSERT INTO Art_historisches_Objekt VALUES (96,'Bezugszaehlstelle_Auslverkehr')
INSERT INTO Art_historisches_Objekt VALUES (97,'Bezugszaehlstelle_Gesamtverk')
INSERT INTO Art_historisches_Objekt VALUES (98,'VBA_Wetterstation')
INSERT INTO Art_historisches_Objekt VALUES (99,'SWIS_GMA_Messstelle')
INSERT INTO Art_historisches_Objekt VALUES (100,'Kombination_von_Anlagentypen')
INSERT INTO Art_historisches_Objekt VALUES (101,'SB_Anlagentyp')
INSERT INTO Art_historisches_Objekt VALUES (102,'SB_Anzeigezustaende')
INSERT INTO Art_historisches_Objekt VALUES (103,'WW_Anzeigezustaende')
INSERT INTO Art_historisches_Objekt VALUES (104,'WW_Wirkungsbereiche')
INSERT INTO Art_historisches_Objekt VALUES (105,'KB_Anlagentyp')
INSERT INTO Art_historisches_Objekt VALUES (106,'KB_Anzeigezustaende')
INSERT INTO Art_historisches_Objekt VALUES (107,'richtungsbezogener_WB')
INSERT INTO Art_historisches_Objekt VALUES (108,'Angaben_zum_Knotenpunkt')
INSERT INTO Art_historisches_Objekt VALUES (109,'Betriebsform')
INSERT INTO Art_historisches_Objekt VALUES (110,'RW_Anzeigezustaende')
INSERT INTO Art_historisches_Objekt VALUES (111,'RW_Wirkungsbereich')
INSERT INTO Art_historisches_Objekt VALUES (112,'Art_der_Stromversorgung')
INSERT INTO Art_historisches_Objekt VALUES (113,'manuelle_Steuerung')
INSERT INTO Art_historisches_Objekt VALUES (114,'Datenuebertragungssystem')
INSERT INTO Art_historisches_Objekt VALUES (115,'Unterzentrale')
INSERT INTO Art_historisches_Objekt VALUES (116,'Verkehrsrechnerzentrale')
INSERT INTO Art_historisches_Objekt VALUES (117,'Ueberwachung_der_Anlage')
INSERT INTO Art_historisches_Objekt VALUES (118,'Wechselverkehrszeichen')
INSERT INTO Art_historisches_Objekt VALUES (119,'Art_der_Aufstellung')
INSERT INTO Art_historisches_Objekt VALUES (120,'Anzahl_der_Anzeigequerschnitte')
INSERT INTO Art_historisches_Objekt VALUES (121,'Detektionsmethode')
INSERT INTO Art_historisches_Objekt VALUES (122,'Art_der_Anordnung')
INSERT INTO Art_historisches_Objekt VALUES (123,'Art_der_erfassten_Daten')
INSERT INTO Art_historisches_Objekt VALUES (124,'Anzahl_der_Messquerschnitte')
INSERT INTO Art_historisches_Objekt VALUES (125,'Wegweiserbild')
INSERT INTO Art_historisches_Objekt VALUES (126,'Beschriftungselemente_Symbole')
INSERT INTO Art_historisches_Objekt VALUES (127,'zeitlicher_Gueltigkeitsber')
INSERT INTO Art_historisches_Objekt VALUES (128,'Rotlichtueberwachung')
INSERT INTO Art_historisches_Objekt VALUES (129,'Angaben_zum_Knotenpunkt_LSA')
INSERT INTO Art_historisches_Objekt VALUES (130,'Grundlage_und_Inbetriebn_daten')
INSERT INTO Art_historisches_Objekt VALUES (131,'Angaben_zu_Verkehrsdaten')
INSERT INTO Art_historisches_Objekt VALUES (132,'Signalprogrammparameter')
INSERT INTO Art_historisches_Objekt VALUES (133,'hinterlegte_Programme')
INSERT INTO Art_historisches_Objekt VALUES (134,'akust_oder_taktile_Signalgeber')
INSERT INTO Art_historisches_Objekt VALUES (135,'Angaben_zum_Steuergeraet')
INSERT INTO Art_historisches_Objekt VALUES (136,'Angaben_zur_Verkabelung')
INSERT INTO Art_historisches_Objekt VALUES (137,'Angaben_z_Aufstellvorrichtung')
INSERT INTO Art_historisches_Objekt VALUES (138,'optische_Signalgeber')
INSERT INTO Art_historisches_Objekt VALUES (139,'Erfassungseinrichtungen_IV')
INSERT INTO Art_historisches_Objekt VALUES (140,'Erfassungseinrichtungen_OeV')
INSERT INTO Art_historisches_Objekt VALUES (141,'uebergeordnete_Zentrale')
INSERT INTO Art_historisches_Objekt VALUES (142,'einfacher_Zeitraum')
INSERT INTO Art_historisches_Objekt VALUES (143,'komplexer_Zeitraum')

CREATE TABLE Ereignis (
   Ereignis_ID
      INTEGER NOT NULL PRIMARY KEY,
   laufende_Nummer
      INTEGER NOT NULL,
   Wirksamkeitsdatum
      CHAR(10) NOT NULL, -- Datum
   CHECK ( Wirksamkeitsdatum LIKE '__.__.____' ),
   gehoert_zu_Projekt
      INTEGER REFERENCES Projekt_Strassenbau,
   hat_Dokument_zur_Erlaeuterung
      INTEGER REFERENCES Administration.Dokument
)

CREATE TABLE Ereignis__in_Bauamt (
   Ereignis
      INTEGER NOT NULL REFERENCES Ereignis,
   Strassenbaudienststelle
      INTEGER NOT NULL REFERENCES Administration.Strassenbaudienststelle
)

CREATE TABLE Projekt_Strassenbau (
   Projekt_Strassenbau_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE identisches_Netzteil (
   identisches_Netzteil_ID
      INTEGER NOT NULL PRIMARY KEY,
   mit_Veraenderungsart
      CHAR(2) REFERENCES Veraenderungsart,
   war_Teilabschnitt
      INTEGER REFERENCES Teilabschnitt_IdNT,
   wurde_zu_Teilabschnitt
      INTEGER REFERENCES Teilabschnitt_IdNT,
   Teil_von_Ereignis
      INTEGER NOT NULL REFERENCES Ereignis,
   CHECK ( ( war_Teilabschnitt IS NOT NULL ) OR ( wurde_zu_Teilabschnitt IS NOT NULL ) )
)

CREATE TABLE Veraenderungsart (
   Kennung
      CHAR(2) NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Veraenderungsart VALUES ('NB','Neubau')
INSERT INTO Veraenderungsart VALUES ('VB','Vollausbau')
INSERT INTO Veraenderungsart VALUES ('ZB','Zwischenausbau')
INSERT INTO Veraenderungsart VALUES ('RE','Rekultivierung')
INSERT INTO Veraenderungsart VALUES ('DT','Deckenerneuerung im Tiefeinbau')
INSERT INTO Veraenderungsart VALUES ('DH','Deckenerneuerung im Hocheinbau')
INSERT INTO Veraenderungsart VALUES ('WI','Widmung')
INSERT INTO Veraenderungsart VALUES ('AU','Aufstufung')
INSERT INTO Veraenderungsart VALUES ('AB','Abstufung')
INSERT INTO Veraenderungsart VALUES ('UM','Umnumerierung in der ' ||
 'Straenbezeichnung')
INSERT INTO Veraenderungsart VALUES ('EZ','Einziehung')
INSERT INTO Veraenderungsart VALUES ('OD','Verlegung der OD-Grenze')
INSERT INTO Veraenderungsart VALUES ('UI','UI-Vertrag')
INSERT INTO Veraenderungsart VALUES ('GR','Grenzverlegung')
INSERT INTO Veraenderungsart VALUES ('SB','nderung der Abschnitts-/' ||
 'Astbezeichnung')
INSERT INTO Veraenderungsart VALUES ('LN','Lngennderung infolge Neumessung')
INSERT INTO Veraenderungsart VALUES ('KO','Korrektur')

CREATE TABLE Teilabschnitt_IdNT (
   Teilabschnitt_IdNT_ID
      INTEGER NOT NULL PRIMARY KEY,
   Station_1
      REAL NOT NULL, -- Meter
   CHECK ( Station_1>=0 ),
   auf_Abschnitt_oder_Ast
      INTEGER NOT NULL REFERENCES Strassennetz.Abschnitt_oder_Ast,
   Station_2
      REAL NOT NULL, -- Meter
   CHECK ( Station_2>=0 ),
)


